require.config({
    waitSeconds: 7,
    paths: {
        'jquery': 'lib/jquery/jquery-1.7.2.min',
        'createjs-easeljs': 'lib/createjs/easeljs/easeljs-0.6.1.min',
        'createjs-preloadjs': 'lib/createjs/preloadjs/preloadjs-0.3.1.min',
        'createjs-movieclip': 'lib/createjs/easeljs/movieclip-0.6.1.min',
        'createjs-tweenjs': 'lib/createjs/tweenjs/tweenjs-0.4.0.min',
        'createjs-colorfilter': 'lib/createjs/easeljs/ColorFilter',
        'createjs-soundjs': 'lib/createjs/soundjs_5/soundjs-0.5.2.min',
        //'createjs-soundjs': 'lib/createjs/soundjs/soundjs-0.4.1.min',
        'greensock-tweenlite': 'lib/greensock/TweenLite.min',
        'greensock-timelinelite': 'lib/greensock/TimelineLite.min',
        'greensock-easepack': 'lib/greensock/easing/EasePack.min',
        'greensock-cssplugin': 'lib/greensock/plugins/CSSPlugin.min',
        'greensock-easelplugin': 'lib/greensock/plugins/EaselPlugin.min',
        'greensock-colorprops': 'lib/greensock/plugins/ColorPropsPlugin.min',
        'hammerjs': 'lib/hammerjs/hammer.min',
        'facebook': 'http://connect.facebook.net/en_US/all'
    },
    shim: {
        'lib/wk/Preloader': [
            'lib/wk/pixelRatio',
            'jquery'
        ],
        'createjs-movieclip': [
            'createjs-easeljs',
            'createjs-tweenjs'
        ],
        'createjs-colorfilter': [
            'createjs-easeljs'
        ],
        'app/scenery-desktop': [
            'createjs-movieclip'
        ],
        'app/scenery-mobile': [
            'createjs-movieclip'
        ],
        'lib/hammerjs/hammer.fakemultitouch': [
            'hammerjs'
        ],
        'lib/hammerjs/hammer.showtouches': [
            'hammerjs'
        ],
        'greensock-easelplugin': [
            'greensock-tweenlite',
            'createjs-easeljs',
            'createjs-colorfilter'
        ],
        'facebook': {
            exports: 'FB'
        },
        'app/app-desktop': [
            'jquery',
            'createjs-easeljs',
            'createjs-preloadjs',
            'createjs-soundjs',
            'greensock-tweenlite',
            'greensock-easepack',
            'greensock-timelinelite',
            'greensock-cssplugin',
            'greensock-easelplugin',
            'greensock-colorprops',
            'app/scenery-desktop',
            'hammerjs',

        ],
        'app/app-mobile': [
            'jquery',
            'createjs-easeljs',
            'createjs-preloadjs',
            'createjs-soundjs',
            'greensock-tweenlite',
            'greensock-easepack',
            'greensock-timelinelite',
            'greensock-cssplugin',
            'greensock-easelplugin',
            'greensock-colorprops',
            'app/scenery-mobile',
            'hammerjs',

        ]
    }
});
require([
    'lib/misc/console.min',
    'lib/wk/mobileDetect',
    'lib/wk/Preloader',

], function () {
    var _this = this;
    $(document).ready(function () {
        getOS();
        var isNewAndroid = true;
        var isAndroidWeb = false;
        var isNewSafari = true;
        if(userBrowser == 'Safari' && parseFloat(userBrowserVer) <= 4) {
            isNewSafari = false;
        }
        if(userOS == 'Android' && parseFloat(userOSver) < 4.0) {
            isNewAndroid = false;
        }
        var isChrome = window['chrome'];
        if(isChrome) {
        } else {
            var ua = navigator.userAgent.toLowerCase();
            var isAndroid = ua.indexOf("android") > -1;
            if(isAndroid) {
                isAndroidWeb = true;
            }
        }
        function supports_canvas() {
            var el = document.createElement('canvas');
            return !!el.getContext;
        }
        if(isNewSafari && !isKindle && isNewAndroid && supports_canvas() && !isAndroidWeb) {
        } else {
            var outdatedMessage = $('<div id="outdatedMessage" />');
            $('#wrapper').append(outdatedMessage);
            return;
        }
        ;
        var jq_canvas = $('<canvas id="preloader"/>');
        jq_canvas.css({
            'width': $(window).width(),
            'height': $(window).height()
        });
        var jq_wrapper = $('#wrapper');
        jq_wrapper.append(jq_canvas);
        var preloader = new Preloader({
            canvas: jq_canvas[0],
            sheet: 'img/coke_white.png',
            bottleColor: '#e41e2b'
        });
        preloader.start();
        var preloaderRenderIntervalID = setInterval(function () {
            preloader.draw();
        }, 50);
        if(isMobile.any()) {
            console.log('--- ' + _this + ' - itsa me, a mobile!');
            require([
                'app/app-mobile'
            ], function () {
                console.log('--- ' + _this + ' - secondary require complete: desktop');
                app.mobile.run(function ($togglePauseFunction) {
                    console.log('--- ' + _this + ' - run callback executed');
                    clearInterval(preloaderRenderIntervalID);
                    preloader.stop();
                    _this.__globalTogglePauseForTheAppButDontCollideWithAnythingElse = $togglePauseFunction;
                });
            });
        } else {
            console.log('--- ' + _this + ' - not mobile!');
            require([
                'app/app-desktop'
            ], function () {
                console.log('--- ' + _this + ' - secondary require complete: desktop');
                app.desktop.run(function ($togglePauseFunction) {
                    console.log('--- ' + _this + ' - run callback executed');
                    clearInterval(preloaderRenderIntervalID);
                    preloader.stop();
                    _this.__globalTogglePauseForTheAppButDontCollideWithAnythingElse = $togglePauseFunction;
                });
            });
        }
    });
});
