// Calculate proper canvas scaling ratio using devicePixelRatio and backingStoreRatio
// See resoning here http://www.html5rocks.com/en/tutorials/canvas/hidpi/
function dbRatio() {
	if (typeof ctx === "undefined") {
	  return 1;
	}

	var val,
	  devicePixelRatio = window.devicePixelRatio || 1,
	  backingStoreRatio = ctx.webkitBackingStorePixelRatio ||
						  ctx.mozBackingStorePixelRatio ||
						  ctx.msBackingStorePixelRatio ||
						  ctx.oBackingStorePixelRatio ||
						  ctx.backingStorePixelRatio || 1;

	val = devicePixelRatio/backingStoreRatio;
	// Normalize to a value of 1 or 2 because
	// nexus devices return 1.3 resulting in incorrect scaling 
	return (val >= 2) ? 2 : 1;
}

deviceBackingRatio = dbRatio();